/*
 * pi - P user Interface
 * 
 * $Id: root.c,v 1.1.1.1 2001/02/13 18:30:27 malekith Exp $
 * Author: Michal Moskal <malekith@pld.org.pl>
 * include COPYING-GNU
 */

#include <pi/pi.h>
#include <string.h>

void pi_root_draw(struct pi_object *ctx)
{
	int c1, c2;
	char *s;

	c1 = pi_int(color_norm);
	c2 = pi_int(color_norm_hl);
	
	pi_color(c1);
	pi_fill(' ', ctx->x, ctx->y, ctx->w, ctx->h);
	
	pi_goto(0, 0);
	pi_addstr_alt(pi_ptr(text_left_up), -1, c1, c2);
	
	pi_goto(0, 0);
	s = pi_ptr(text_middle_up);
	pi_goto((ctx->w - pi_strlen_alt(s)) / 2, 0);
	pi_addstr_alt(s, -1, c1, c2);

	pi_goto(0, 0);
	s = pi_ptr(text_right_up);
	pi_goto((ctx->w - pi_strlen_alt(s)), 0);
	pi_addstr_alt(s, -1, c1, c2);

	pi_goto(0, ctx->h - 1);
	pi_addstr_alt(pi_ptr(text_left_down), -1, c1, c2);
	
	pi_goto(0, ctx->h - 1);
	s = pi_ptr(text_middle_down);
	pi_goto((ctx->w - pi_strlen_alt(s)) / 2, ctx->h - 1);
	pi_addstr_alt(s, -1, c1, c2);

	pi_goto(0, ctx->h - 1);
	s = pi_ptr(text_right_down);
	pi_goto((ctx->w - pi_strlen_alt(s)), ctx->h - 1);
	pi_addstr_alt(s, -1, c1, c2);
}

struct pi_object *pi_new_root(struct pi_object *ctx, struct pi_object *super)
{
	pi_new_init((0,
			pi_tag_flags, pi_f_can_get_focus, /* :) */
			pi_tag_draw_handler, pi_root_draw,
			pi_tag_text_right_up, "",
			pi_tag_text_left_up, "",
			pi_tag_text_middle_up, "",
			pi_tag_text_right_down, "",
			pi_tag_text_left_down, "",
			pi_tag_text_middle_down, "",
			PI_COLOR(norm, cyan, black),
			PI_COLOR(norm_hl, lightcyan, black),
	0), object);

	pi_init_size(ret, 0, 0, pi_screen_width, pi_screen_height);

	return ret;
}
